<?php defined('SYSPATH') or die('No direct access allowed.');

/**
 * This class supports Services
 *
 * @package    OSB
 * @subpackage DOMAIN
 * @category   Models
 * @author     Deon George
 * @copyright  (c) 2010 Open Source Billing
 * @license    http://dev.osbill.net/license.html
 */
class Model_Service_DOMAIN extends Model_Service {
	protected $_table_name = 'service__domain';
	protected $_updated_column = FALSE;

	// Relationships
	protected $_has_one = array(
		'host_tld'=>array('foreign_key'=>'id','far_key'=>'domain_tld_id'),
		'host_registrar_plugin'=>array('foreign_key'=>'id','far_key'=>'domain_registrar_id'),
	);
	protected $_belongs_to = array(
		'service'=>array(),
	);

	protected $_display_filters = array(
		'domain_expire'=>array(
			array('Config::date',array(':value')),
		),
	);

	protected function _service_name() {
		return sprintf('%s - %s','Domain',$this->name());
	}

	protected function _service_view() {
	}

	/**
	 * Get specific service details for use in other modules
	 * For Example: Invoice
	 *
	 * @todo Make the rendered items configurable
	 */
	protected function _details($type) {
		switch ($type) {
			default:
				throw new Kohana_Exception('Unkown detail request :type',array(':type'=>$type));
		}
	}

	protected function _admin_update() {
	}

	public function name() {
		return sprintf('%s.%s',$this->domain_name,$this->host_tld->name);
	}
}
?>
